uthash.h File Reference
`#include <string.h>`
`#include <stddef.h>`
`#include <stdlib.h>`
`#include <stdint.h>`
Include dependency graph for uthash.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | UT_hash_bucket
struct | UT_hash_table
struct | UT_hash_handle

## Macros

#define | DECLTYPE(x) (__typeof(x))
#define | DECLTYPE_ASSIGN(dst, src)
#define | UTHASH_VERSION 1.9.9
#define | uthash_fatal(msg) exit(-1) /* fatal error (out of memory,etc) */
#define | uthash_malloc(sz) malloc(sz) /* malloc fcn */
#define | uthash_free(ptr, sz) free(ptr) /* free fcn */
#define | uthash_noexpand_fyi(tbl) /* can be defined to log noexpand */
#define | uthash_expand_fyi(tbl) /* can be defined to log expands */
#define | HASH_INITIAL_NUM_BUCKETS 32 /* initial number of buckets */
#define | HASH_INITIAL_NUM_BUCKETS_LOG2 5 /* lg2 of initial number of buckets */
#define | HASH_BKT_CAPACITY_THRESH 10 /* expand when bucket count reaches */
#define | ELMT_FROM_HH(tbl, hhp) ((void*)(((char*)(hhp)) - ((tbl)->hho)))
#define | HASH_FIND(hh, head, keyptr, keylen, out)
#define | HASH_BLOOM_MAKE(tbl)
#define | HASH_BLOOM_FREE(tbl)
#define | HASH_BLOOM_ADD(tbl, hashv)
#define | HASH_BLOOM_TEST(tbl, hashv) (1)
#define | HASH_BLOOM_BYTELEN 0
#define | HASH_MAKE_TABLE(hh, head)
#define | HASH_ADD(hh, head, fieldname, keylen_in, add) HASH_ADD_KEYPTR(hh,head,&((add)->fieldname),keylen_in,add)
#define | HASH_REPLACE(hh, head, fieldname, keylen_in, add, replaced)
#define | HASH_ADD_KEYPTR(hh, head, keyptr, keylen_in, add)
#define | HASH_TO_BKT(hashv, num_bkts, bkt)
#define | HASH_DELETE(hh, head, delptr)
#define | HASH_FIND_STR(head, findstr, out) HASH_FIND(hh,head,findstr,(unsigned)strlen(findstr),out)
#define | HASH_ADD_STR(head, strfield, add) HASH_ADD(hh,head,strfield[0],strlen(add->strfield),add)
#define | HASH_REPLACE_STR(head, strfield, add, replaced) HASH_REPLACE(hh,head,strfield[0],(unsigned)strlen(add->strfield),add,replaced)
#define | HASH_FIND_INT(head, findint, out) HASH_FIND(hh,head,findint,sizeof(int),out)
#define | HASH_ADD_INT(head, intfield, add) HASH_ADD(hh,head,intfield,sizeof(int),add)
#define | HASH_REPLACE_INT(head, intfield, add, replaced) HASH_REPLACE(hh,head,intfield,sizeof(int),add,replaced)
#define | HASH_FIND_PTR(head, findptr, out) HASH_FIND(hh,head,findptr,sizeof(void *),out)
#define | HASH_ADD_PTR(head, ptrfield, add) HASH_ADD(hh,head,ptrfield,sizeof(void *),add)
#define | HASH_REPLACE_PTR(head, ptrfield, add, replaced) HASH_REPLACE(hh,head,ptrfield,sizeof(void *),add,replaced)
#define | HASH_DEL(head, delptr) HASH_DELETE(hh,head,delptr)
#define | HASH_FSCK(hh, head)
#define | HASH_EMIT_KEY(hh, head, keyptr, fieldlen)
#define | HASH_FCN HASH_JEN
#define | HASH_BER(key, keylen, num_bkts, hashv, bkt)
#define | HASH_SAX(key, keylen, num_bkts, hashv, bkt)
#define | HASH_FNV(key, keylen, num_bkts, hashv, bkt)
#define | HASH_OAT(key, keylen, num_bkts, hashv, bkt)
#define | HASH_JEN_MIX(a, b, c)
#define | HASH_JEN(key, keylen, num_bkts, hashv, bkt)
#define | get16bits(d)
#define | HASH_SFH(key, keylen, num_bkts, hashv, bkt)
#define | HASH_KEYCMP(a, b, len) memcmp(a,b,len)
#define | HASH_FIND_IN_BKT(tbl, hh, head, keyptr, keylen_in, out)
#define | HASH_ADD_TO_BKT(head, addhh)
#define | HASH_DEL_IN_BKT(hh, head, hh_del)
#define | HASH_EXPAND_BUCKETS(tbl)
#define | HASH_SORT(head, cmpfcn) HASH_SRT(hh,head,cmpfcn)
#define | HASH_SRT(hh, head, cmpfcn)
#define | HASH_SELECT(hh_dst, dst, hh_src, src, cond)
#define | HASH_CLEAR(hh, head)
#define | HASH_OVERHEAD(hh, head)
#define | HASH_ITER(hh, head, el, tmp)
#define | HASH_COUNT(head) HASH_CNT(hh,head)
#define | HASH_CNT(hh, head) ((head)?((head)->hh.tbl->num_items):0)
#define | HASH_SIGNATURE 0xa0111fe1
#define | HASH_BLOOM_SIGNATURE 0xb12220f2

## Typedefs

typedef struct UT_hash_bucket | UT_hash_bucket
typedef struct UT_hash_table | UT_hash_table
typedef struct UT_hash_handle | UT_hash_handle

## Macro Definition Documentation

## DECLTYPE

#define DECLTYPE | ( |  | x | ) | (__typeof(x))

Definition at line 46 of file uthash.h.

## DECLTYPE_ASSIGN

#define DECLTYPE_ASSIGN | ( |  | dst,
|  |  | src
| ) |  |

Value:
do { \
(dst) = DECLTYPE(dst)(src); \
} while(0)
DECLTYPE
#define DECLTYPE(x)
Definition: uthash.h:46

Definition at line 56 of file uthash.h.

## ELMT_FROM_HH

#define ELMT_FROM_HH | ( |  | tbl,
|  |  | hhp
| ) |  | ((void*)(((char*)(hhp)) - ((tbl)->hho)))

Definition at line 101 of file uthash.h.

## get16bits

#define get16bits | ( |  | d | ) |

Value:
((((uint32_t)(((const uint8_t *)(d))[1])) << 8) \
+(uint32_t)(((const uint8_t *)(d))[0]) )

Definition at line 479 of file uthash.h.

## HASH_ADD

#define HASH_ADD | ( |  | hh,
|  |  | head,
|  |  | fieldname,
|  |  | keylen_in,
|  |  | add
| ) |  | HASH_ADD_KEYPTR(hh,head,&((add)->fieldname),keylen_in,add)

Definition at line 169 of file uthash.h.

## HASH_ADD_INT

#define HASH_ADD_INT | ( |  | head,
|  |  | intfield,
|  |  | add
| ) |  | HASH_ADD(hh,head,intfield,sizeof(int),add)

Definition at line 269 of file uthash.h.

## HASH_ADD_KEYPTR

#define HASH_ADD_KEYPTR | ( |  | hh,
|  |  | head,
|  |  | keyptr,
|  |  | keylen_in,
|  |  | add
| ) |  |

Value:
do { \
unsigned _ha_bkt; \
(add)->hh.next = NULL; \
(add)->hh.key = (char*)(keyptr); \
(add)->hh.keylen = (unsigned)(keylen_in); \
if (!(head)) { \
head = (add); \
(head)->hh.prev = NULL; \
HASH_MAKE_TABLE(hh,head); \
} else { \
(head)->hh.tbl->tail->next = (add); \
(add)->hh.prev = ELMT_FROM_HH((head)->hh.tbl, (head)->hh.tbl->tail); \
(head)->hh.tbl->tail = &((add)->hh); \
} \
(head)->hh.tbl->num_items++; \
(add)->hh.tbl = (head)->hh.tbl; \
HASH_FCN(keyptr,keylen_in, (head)->hh.tbl->num_buckets, \
(add)->hh.hashv, _ha_bkt); \
HASH_ADD_TO_BKT((head)->hh.tbl->buckets[_ha_bkt],&(add)->hh); \
HASH_BLOOM_ADD((head)->hh.tbl,(add)->hh.hashv); \
HASH_EMIT_KEY(hh,head,keyptr,keylen_in); \
HASH_FSCK(hh,head); \
} while(0)
HASH_FCN
#define HASH_FCN
Definition: uthash.h:360
HASH_MAKE_TABLE
#define HASH_MAKE_TABLE(hh, head)
Definition: uthash.h:150
ELMT_FROM_HH
#define ELMT_FROM_HH(tbl, hhp)
Definition: uthash.h:101

Definition at line 182 of file uthash.h.

## HASH_ADD_PTR

#define HASH_ADD_PTR | ( |  | head,
|  |  | ptrfield,
|  |  | add
| ) |  | HASH_ADD(hh,head,ptrfield,sizeof(void *),add)

Definition at line 275 of file uthash.h.

## HASH_ADD_STR

#define HASH_ADD_STR | ( |  | head,
|  |  | strfield,
|  |  | add
| ) |  | HASH_ADD(hh,head,strfield[0],strlen(add->strfield),add)

Definition at line 263 of file uthash.h.

## HASH_ADD_TO_BKT

#define HASH_ADD_TO_BKT | ( |  | head,
|  |  | addhh
| ) |  |

Value:
do { \
head.count++; \
(addhh)->hh_next = head.hh_head; \
(addhh)->hh_prev = NULL; \
if (head.hh_head) { (head).hh_head->hh_prev = (addhh); } \
(head).hh_head=addhh; \
if (head.count >= ((head.expand_mult+1) * HASH_BKT_CAPACITY_THRESH) \
&& (addhh)->tbl->noexpand != 1) { \
HASH_EXPAND_BUCKETS((addhh)->tbl); \
} \
} while(0)
UT_hash_handle::hh_next
struct UT_hash_handle * hh_next
Definition: uthash.h:957
HASH_BKT_CAPACITY_THRESH
#define HASH_BKT_CAPACITY_THRESH
Definition: uthash.h:98
UT_hash_handle::tbl
struct UT_hash_table * tbl
Definition: uthash.h:953
UT_hash_handle::hh_prev
struct UT_hash_handle * hh_prev
Definition: uthash.h:956

Definition at line 625 of file uthash.h.

## HASH_BER

#define HASH_BER | ( |  | key,
|  |  | keylen,
|  |  | num_bkts,
|  |  | hashv,
|  |  | bkt
| ) |  |

Value:
do { \
unsigned _hb_keylen=keylen; \
char *_hb_key=(char*)(key); \
(hashv) = 0; \
while (_hb_keylen--) { (hashv) = (((hashv) << 5) + (hashv)) + *_hb_key++; } \
bkt = (hashv) & (num_bkts-1); \
} while (0)
UT_hash_handle::keylen
unsigned keylen
Definition: uthash.h:959
UT_hash_handle::hashv
unsigned hashv
Definition: uthash.h:960
UT_hash_handle::key
void * key
Definition: uthash.h:958

Definition at line 364 of file uthash.h.

## HASH_BKT_CAPACITY_THRESH

#define HASH_BKT_CAPACITY_THRESH 10 /* expand when bucket count reaches */

Definition at line 98 of file uthash.h.

## HASH_BLOOM_ADD

#define HASH_BLOOM_ADD | ( |  | tbl,
|  |  | hashv
| ) |  |

Definition at line 145 of file uthash.h.

## HASH_BLOOM_BYTELEN

#define HASH_BLOOM_BYTELEN 0

Definition at line 147 of file uthash.h.

## HASH_BLOOM_FREE

#define HASH_BLOOM_FREE | ( |  | tbl | ) |

Definition at line 144 of file uthash.h.

## HASH_BLOOM_MAKE

#define HASH_BLOOM_MAKE | ( |  | tbl | ) |

Definition at line 143 of file uthash.h.

## HASH_BLOOM_SIGNATURE

#define HASH_BLOOM_SIGNATURE 0xb12220f2

Definition at line 917 of file uthash.h.

## HASH_BLOOM_TEST

#define HASH_BLOOM_TEST | ( |  | tbl,
|  |  | hashv
| ) |  | (1)

Definition at line 146 of file uthash.h.

## HASH_CLEAR

#define HASH_CLEAR | ( |  | hh,
|  |  | head
| ) |  |

Value:
do { \
if (head) { \
uthash_free((head)->hh.tbl->buckets, \
(head)->hh.tbl->num_buckets*sizeof(struct UT_hash_bucket)); \
HASH_BLOOM_FREE((head)->hh.tbl); \
uthash_free((head)->hh.tbl, sizeof(UT_hash_table)); \
(head)=NULL; \
} \
} while(0)
UT_hash_table
Definition: uthash.h:919
UT_hash_bucket
Definition: uthash.h:895

Definition at line 863 of file uthash.h.

## HASH_CNT

#define HASH_CNT | ( |  | hh,
|  |  | head
| ) |  | ((head)?((head)->hh.tbl->num_items):0)

Definition at line 893 of file uthash.h.

## HASH_COUNT

#define HASH_COUNT | ( |  | head | ) | HASH_CNT(hh,head)

Definition at line 892 of file uthash.h.

## HASH_DEL

#define HASH_DEL | ( |  | head,
|  |  | delptr
| ) |  | HASH_DELETE(hh,head,delptr)

Definition at line 279 of file uthash.h.

## HASH_DEL_IN_BKT

#define HASH_DEL_IN_BKT | ( |  | hh,
|  |  | head,
|  |  | hh_del
| ) |  |

Value:
(head).count--; \
if ((head).hh_head == hh_del) { \
(head).hh_head = hh_del->hh_next; \
} \
if (hh_del->hh_prev) { \
hh_del->hh_prev->hh_next = hh_del->hh_next; \
} \
if (hh_del->hh_next) { \
hh_del->hh_next->hh_prev = hh_del->hh_prev; \
}

Definition at line 639 of file uthash.h.

## HASH_DELETE

#define HASH_DELETE | ( |  | hh,
|  |  | head,
|  |  | delptr
| ) |  |

Definition at line 224 of file uthash.h.

## HASH_EMIT_KEY

#define HASH_EMIT_KEY | ( |  | hh,
|  |  | head,
|  |  | keyptr,
|  |  | fieldlen
| ) |  |

Definition at line 353 of file uthash.h.

## HASH_EXPAND_BUCKETS

#define HASH_EXPAND_BUCKETS | ( |  | tbl | ) |

Definition at line 680 of file uthash.h.

## HASH_FCN

#define HASH_FCN HASH_JEN

Definition at line 360 of file uthash.h.

## HASH_FIND

#define HASH_FIND | ( |  | hh,
|  |  | head,
|  |  | keyptr,
|  |  | keylen,
|  |  | out
| ) |  |

Value:
do { \
out=NULL; \
if (head) { \
unsigned _hf_bkt,_hf_hashv; \
HASH_FCN(keyptr,keylen, (head)->hh.tbl->num_buckets, _hf_hashv, _hf_bkt); \
if (HASH_BLOOM_TEST((head)->hh.tbl, _hf_hashv)) { \
HASH_FIND_IN_BKT((head)->hh.tbl, hh, (head)->hh.tbl->buckets[ _hf_bkt ], \
keyptr,keylen,out); \
} \
} \
} while (0)
UT_hash_handle::keylen
unsigned keylen
Definition: uthash.h:959
HASH_BLOOM_TEST
#define HASH_BLOOM_TEST(tbl, hashv)
Definition: uthash.h:146

Definition at line 103 of file uthash.h.

## HASH_FIND_IN_BKT

#define HASH_FIND_IN_BKT | ( |  | tbl,
|  |  | hh,
|  |  | head,
|  |  | keyptr,
|  |  | keylen_in,
|  |  | out
| ) |  |

Value:
do { \
if (head.hh_head) DECLTYPE_ASSIGN(out,ELMT_FROM_HH(tbl,head.hh_head)); \
else out=NULL; \
while (out) { \
if ((out)->hh.keylen == keylen_in) { \
if ((HASH_KEYCMP((out)->hh.key,keyptr,keylen_in)) == 0) break; \
} \
if ((out)->hh.hh_next) DECLTYPE_ASSIGN(out,ELMT_FROM_HH(tbl,(out)->hh.hh_next)); \
else out = NULL; \
} \
} while(0)
UT_hash_handle::hh_next
struct UT_hash_handle * hh_next
Definition: uthash.h:957
DECLTYPE_ASSIGN
#define DECLTYPE_ASSIGN(dst, src)
Definition: uthash.h:56
UT_hash_handle::tbl
struct UT_hash_table * tbl
Definition: uthash.h:953
HASH_KEYCMP
#define HASH_KEYCMP(a, b, len)
Definition: uthash.h:608
ELMT_FROM_HH
#define ELMT_FROM_HH(tbl, hhp)
Definition: uthash.h:101

Definition at line 611 of file uthash.h.

## HASH_FIND_INT

#define HASH_FIND_INT | ( |  | head,
|  |  | findint,
|  |  | out
| ) |  | HASH_FIND(hh,head,findint,sizeof(int),out)

Definition at line 267 of file uthash.h.

## HASH_FIND_PTR

#define HASH_FIND_PTR | ( |  | head,
|  |  | findptr,
|  |  | out
| ) |  | HASH_FIND(hh,head,findptr,sizeof(void *),out)

Definition at line 273 of file uthash.h.

## HASH_FIND_STR

#define HASH_FIND_STR | ( |  | head,
|  |  | findstr,
|  |  | out
| ) |  | HASH_FIND(hh,head,findstr,(unsigned)strlen(findstr),out)

Definition at line 261 of file uthash.h.

## HASH_FNV

#define HASH_FNV | ( |  | key,
|  |  | keylen,
|  |  | num_bkts,
|  |  | hashv,
|  |  | bkt
| ) |  |

Value:
do { \
unsigned _fn_i; \
char *_hf_key=(char*)(key); \
hashv = 2166136261UL; \
for(_fn_i=0; _fn_i < keylen; _fn_i++) { \
hashv = hashv ^ _hf_key[_fn_i]; \
hashv = hashv * 16777619; \
} \
bkt = hashv & (num_bkts-1); \
} while(0)
UT_hash_handle::keylen
unsigned keylen
Definition: uthash.h:959
UT_hash_handle::hashv
unsigned hashv
Definition: uthash.h:960
UT_hash_handle::key
void * key
Definition: uthash.h:958

Definition at line 386 of file uthash.h.

## HASH_FSCK

#define HASH_FSCK | ( |  | hh,
|  |  | head
| ) |  |

Definition at line 339 of file uthash.h.

## HASH_INITIAL_NUM_BUCKETS

#define HASH_INITIAL_NUM_BUCKETS 32 /* initial number of buckets */

Definition at line 96 of file uthash.h.

## HASH_INITIAL_NUM_BUCKETS_LOG2

#define HASH_INITIAL_NUM_BUCKETS_LOG2 5 /* lg2 of initial number of buckets */

Definition at line 97 of file uthash.h.

## HASH_ITER

#define HASH_ITER | ( |  | hh,
|  |  | head,
|  |  | el,
|  |  | tmp
| ) |  |

Value:
for((el)=(head),(tmp)=DECLTYPE(el)((head)?(head)->hh.next:NULL); \
el; (el)=(tmp),(tmp)=DECLTYPE(el)((tmp)?(tmp)->hh.next:NULL))
DECLTYPE
#define DECLTYPE(x)
Definition: uthash.h:46

Definition at line 886 of file uthash.h.

## HASH_JEN

#define HASH_JEN | ( |  | key,
|  |  | keylen,
|  |  | num_bkts,
|  |  | hashv,
|  |  | bkt
| ) |  |

Definition at line 427 of file uthash.h.

## HASH_JEN_MIX

#define HASH_JEN_MIX | ( |  | a,
|  |  | b,
|  |  | c
| ) |  |

Value:
do { \
a -= b; a -= c; a ^= ( c >> 13 ); \
b -= c; b -= a; b ^= ( a << 8 ); \
c -= a; c -= b; c ^= ( b >> 13 ); \
a -= b; a -= c; a ^= ( c >> 12 ); \
b -= c; b -= a; b ^= ( a << 16 ); \
c -= a; c -= b; c ^= ( b >> 5 ); \
a -= b; a -= c; a ^= ( c >> 3 ); \
b -= c; b -= a; b ^= ( a << 10 ); \
c -= a; c -= b; c ^= ( b >> 15 ); \
} while (0)

Definition at line 414 of file uthash.h.

## HASH_KEYCMP

#define HASH_KEYCMP | ( |  | a,
|  |  | b,
|  |  | len
| ) |  | memcmp(a,b,len)

Definition at line 608 of file uthash.h.

## HASH_MAKE_TABLE

#define HASH_MAKE_TABLE | ( |  | hh,
|  |  | head
| ) |  |

Value:
do { \
(head)->hh.tbl = (UT_hash_table*)uthash_malloc( \
sizeof(UT_hash_table)); \
if (!((head)->hh.tbl)) { uthash_fatal( "out of memory"); } \
memset((head)->hh.tbl, 0, sizeof(UT_hash_table)); \
(head)->hh.tbl->tail = &((head)->hh); \
(head)->hh.tbl->num_buckets = HASH_INITIAL_NUM_BUCKETS; \
(head)->hh.tbl->log2_num_buckets = HASH_INITIAL_NUM_BUCKETS_LOG2; \
(head)->hh.tbl->hho = (char*)(&(head)->hh) - (char*)(head); \
(head)->hh.tbl->buckets = (UT_hash_bucket*)uthash_malloc( \
HASH_INITIAL_NUM_BUCKETS*sizeof(struct UT_hash_bucket)); \
if (! (head)->hh.tbl->buckets) { uthash_fatal( "out of memory"); } \
memset((head)->hh.tbl->buckets, 0, \
HASH_INITIAL_NUM_BUCKETS*sizeof(struct UT_hash_bucket)); \
HASH_BLOOM_MAKE((head)->hh.tbl); \
(head)->hh.tbl->signature = HASH_SIGNATURE; \
} while(0)
HASH_INITIAL_NUM_BUCKETS
#define HASH_INITIAL_NUM_BUCKETS
Definition: uthash.h:96
HASH_SIGNATURE
#define HASH_SIGNATURE
Definition: uthash.h:916
HASH_INITIAL_NUM_BUCKETS_LOG2
#define HASH_INITIAL_NUM_BUCKETS_LOG2
Definition: uthash.h:97
uthash_malloc
#define uthash_malloc(sz)
Definition: uthash.h:82
UT_hash_table
Definition: uthash.h:919
UT_hash_bucket
Definition: uthash.h:895
uthash_fatal
#define uthash_fatal(msg)
Definition: uthash.h:79

Definition at line 150 of file uthash.h.

## HASH_OAT

#define HASH_OAT | ( |  | key,
|  |  | keylen,
|  |  | num_bkts,
|  |  | hashv,
|  |  | bkt
| ) |  |

Value:
do { \
unsigned _ho_i; \
char *_ho_key=(char*)(key); \
hashv = 0; \
for(_ho_i=0; _ho_i < keylen; _ho_i++) { \
hashv += _ho_key[_ho_i]; \
hashv += (hashv << 10); \
hashv ^= (hashv >> 6); \
} \
hashv += (hashv << 3); \
hashv ^= (hashv >> 11); \
hashv += (hashv << 15); \
bkt = hashv & (num_bkts-1); \
} while(0)
UT_hash_handle::keylen
unsigned keylen
Definition: uthash.h:959
UT_hash_handle::hashv
unsigned hashv
Definition: uthash.h:960
UT_hash_handle::key
void * key
Definition: uthash.h:958

Definition at line 398 of file uthash.h.

## HASH_OVERHEAD

#define HASH_OVERHEAD | ( |  | hh,
|  |  | head
| ) |  |

Value:
((head) ? ( \
(size_t)((((head)->hh.tbl->num_items * sizeof(UT_hash_handle)) + \
((head)->hh.tbl->num_buckets * sizeof(UT_hash_bucket)) + \
(sizeof(UT_hash_table)) + \
(HASH_BLOOM_BYTELEN)))) : 0)
UT_hash_handle
Definition: uthash.h:952
UT_hash_bucket
struct UT_hash_bucket UT_hash_bucket
HASH_BLOOM_BYTELEN
#define HASH_BLOOM_BYTELEN
Definition: uthash.h:147
UT_hash_table
struct UT_hash_table UT_hash_table

Definition at line 874 of file uthash.h.

## HASH_REPLACE

#define HASH_REPLACE | ( |  | hh,
|  |  | head,
|  |  | fieldname,
|  |  | keylen_in,
|  |  | add,
|  |  | replaced
| ) |  |

Value:
do { \
replaced=NULL; \
HASH_FIND(hh,head,&((add)->fieldname),keylen_in,replaced); \
if (replaced!=NULL) { \
HASH_DELETE(hh,head,replaced); \
}; \
HASH_ADD(hh,head,fieldname,keylen_in,add); \
} while(0)

Definition at line 172 of file uthash.h.

## HASH_REPLACE_INT

#define HASH_REPLACE_INT | ( |  | head,
|  |  | intfield,
|  |  | add,
|  |  | replaced
| ) |  | HASH_REPLACE(hh,head,intfield,sizeof(int),add,replaced)

Definition at line 271 of file uthash.h.

## HASH_REPLACE_PTR

#define HASH_REPLACE_PTR | ( |  | head,
|  |  | ptrfield,
|  |  | add,
|  |  | replaced
| ) |  | HASH_REPLACE(hh,head,ptrfield,sizeof(void *),add,replaced)

Definition at line 277 of file uthash.h.

## HASH_REPLACE_STR

#define HASH_REPLACE_STR | ( |  | head,
|  |  | strfield,
|  |  | add,
|  |  | replaced
| ) |  | HASH_REPLACE(hh,head,strfield[0],(unsigned)strlen(add->strfield),add,replaced)

Definition at line 265 of file uthash.h.

## HASH_SAX

#define HASH_SAX | ( |  | key,
|  |  | keylen,
|  |  | num_bkts,
|  |  | hashv,
|  |  | bkt
| ) |  |

Value:
do { \
unsigned _sx_i; \
char *_hs_key=(char*)(key); \
hashv = 0; \
for(_sx_i=0; _sx_i < keylen; _sx_i++) \
hashv ^= (hashv << 5) + (hashv >> 2) + _hs_key[_sx_i]; \
bkt = hashv & (num_bkts-1); \
} while (0)
UT_hash_handle::keylen
unsigned keylen
Definition: uthash.h:959
UT_hash_handle::hashv
unsigned hashv
Definition: uthash.h:960
UT_hash_handle::key
void * key
Definition: uthash.h:958

Definition at line 376 of file uthash.h.

## HASH_SELECT

#define HASH_SELECT | ( |  | hh_dst,
|  |  | dst,
|  |  | hh_src,
|  |  | src,
|  |  | cond
| ) |  |

Definition at line 825 of file uthash.h.

## HASH_SFH

#define HASH_SFH | ( |  | key,
|  |  | keylen,
|  |  | num_bkts,
|  |  | hashv,
|  |  | bkt
| ) |  |

Definition at line 482 of file uthash.h.

## HASH_SIGNATURE

#define HASH_SIGNATURE 0xa0111fe1

Definition at line 916 of file uthash.h.

## HASH_SORT

#define HASH_SORT | ( |  | head,
|  |  | cmpfcn
| ) |  | HASH_SRT(hh,head,cmpfcn)

Definition at line 732 of file uthash.h.

## HASH_SRT

#define HASH_SRT | ( |  | hh,
|  |  | head,
|  |  | cmpfcn
| ) |  |

Definition at line 733 of file uthash.h.

## HASH_TO_BKT

#define HASH_TO_BKT | ( |  | hashv,
|  |  | num_bkts,
|  |  | bkt
| ) |  |

Value:
do { \
bkt = ((hashv) & ((num_bkts) - 1)); \
} while(0)
UT_hash_handle::hashv
unsigned hashv
Definition: uthash.h:960

Definition at line 207 of file uthash.h.

## uthash_expand_fyi

#define uthash_expand_fyi | ( |  | tbl | ) | /* can be defined to log expands */

Definition at line 92 of file uthash.h.

## uthash_fatal

#define uthash_fatal | ( |  | msg | ) | exit(-1) /* fatal error (out of memory,etc) */

Definition at line 79 of file uthash.h.

## uthash_free

#define uthash_free | ( |  | ptr,
|  |  | sz
| ) |  | free(ptr) /* free fcn */

Definition at line 85 of file uthash.h.

## uthash_malloc

#define uthash_malloc | ( |  | sz | ) | malloc(sz) /* malloc fcn */

Definition at line 82 of file uthash.h.

## uthash_noexpand_fyi

#define uthash_noexpand_fyi | ( |  | tbl | ) | /* can be defined to log noexpand */

Definition at line 89 of file uthash.h.

## UTHASH_VERSION

#define UTHASH_VERSION 1.9.9

Definition at line 76 of file uthash.h.

## Typedef Documentation

## UT_hash_bucket

typedef struct UT_hash_bucket UT_hash_bucket

## UT_hash_handle

typedef struct UT_hash_handle UT_hash_handle

## UT_hash_table

typedef struct UT_hash_table UT_hash_table